/**********************************************************************
 Freeciv - Copyright (C) 2005 - The Freeciv Team
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/   
#ifndef FC__GENTREE_H
#define FC__GENTREE_H

#include "shared.h"		/* bool type */

struct gentree_header {
  struct gentree_header *parent;
  struct gentree_header *fchild;
  struct gentree_header *lsibling;
  struct gentree_header *rsibling;
};

void gentree_new(void *pvgentree);
void gentree_insert(void *pvparent, void *vchild);
void gentree_free(void *pvgentree);

void gentree_traverse(void *pgentree, bool (*func)(void *));

#endif
